<?php
/*
Plugin Name: Skype Button - Widget
Plugin URI: http://www.saltando.net/2006/04/03/jugando-con-los-widgets/
Description: Widget version of Skype Button plugin 2.01 (http://anti.masendav.com/skype-button-for-wordpress)
Version: 0.2
Author: Joan Fisbein
Author URI: http://www.saltando.net
*/

  function skype_button_widget_init() {
  	
  	// Check for the required API functions
		if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
			return;
    
    function skype_button_widget_control() {
      echo '<!-- skype_button_widget_control -->' . "\n";
      $options = get_option('skype_button_widget');
  		if (!is_array($options)) {
  			$options = array('title'=>'', 'skype_id'=>'', 'button_theme'=>'transparent_dropdown');
  		}
  		
  		if (isset($_POST['skype_button_widget_submited'])) {
  			$options['skype_id'] = strip_tags(stripslashes($_POST['skype_button_skype_id']));
  			$options['button_theme'] = strip_tags(stripslashes($_POST['skype_button_theme']));
  			$options['title'] = strip_tags(stripslashes($_POST['skype_button_title']));
  			
  			if (skype_button_valid_id_wg($options['skype_id']) && skype_button_valid_theme_wg($options['button_theme'])) {
  			  update_option('skype_button_widget', $options);
  			}
  		}
  		
  		$skype_id = htmlspecialchars($options['skype_id'], ENT_QUOTES);
		  $button_theme = htmlspecialchars($options['button_theme'], ENT_QUOTES);
		  $title = htmlspecialchars($options['title'], ENT_QUOTES);
		  
		  echo '<p style="text-align:left;"><label for="skype_button_title">Title: <input style="width: 200px;" id="skype_button_title" name="skype_button_title" type="text" value="'.$title.'" /></label></p>' . "\n";
		  echo '<p style="text-align:left;"><label for="skype_button_skype_id">Skype Id: <input style="width: 200px;" id="skype_button_skype_id" name="skype_button_skype_id" type="text" value="'.$skype_id.'" /></label></p>' . "\n";
		  echo '<script type="text/javascript">' . "\n";
    	echo 'var visible_preview = "' . $button_theme . '";' . "\n";
    	echo 'function changestyle(el) {' . "\n";
    	echo '	document.getElementById(visible_preview).style.display = "none";' . "\n";
    	echo '	document.getElementById(el.value).style.display = "block";' . "\n";
    	echo '	visible_preview = el.value;' . "\n";
    	echo '}' . "\n";
    	echo '</script>' . "\n";
    	
    	echo '<fieldset class="options"><legend>And choose your style</legend>' . "\n";
    	$buttondir = dirname(__FILE__)."/skype_buttons/";
    	$previews = "";
    	$themes = array();
    	
    	if (is_dir($buttondir)) {
    		if ($dh = opendir($buttondir)) {
    			while (($file = readdir($dh)) !== false) {
    				$fname = $buttondir . $file;
    				if (is_file($fname) && ".html" == substr($fname,-5)) {
    
    					$theme_name = substr(basename($fname),0,-5);
    
    					$selected = ""; // radio button
    					$display = "none"; // preview layer
    					
    					if ($theme_name == $button_theme) {
    						$selected = 'checked';
    						$display = 'block';
    					};
    
    					// attempt to get the human readable name from the first line of the file
    					$fc = file_get_contents($fname);
    					preg_match("|<!-- (.*) - http://www.skype.com/go/skypebuttons|ms", $fc, $matches);
    					
    					print "<input onclick='changestyle(this)' type='radio' name='skype_button_theme' value='".$theme_name."'" . $selected . "> ".$matches[1]."<br/>" . "\n";
    
    					$previews .= "<div id='$theme_name' style='display: $display; height: 150px;'>" . str_replace('{skypeid}',$skype_id,$fc) . '</div>' . "\n";
    				}
    			}
    			closedir($dh);
    		}
    	}
    	
    	echo '<fieldset class="options"><legend>Preview</legend>' . "\n";
	    echo $previews;
	    echo '</fieldset>' . "\n";
	    
	    /*
	    echo '<fieldset class="options"><legend>Notes</legend>';
	    echo '<p>';
	    echo 'Installation instructions and notes can be found at <a href="http://anti.masendav.com/skype-button-for-wordpress/">this plugins homepage</a>.';
	    echo '</p>';
	    echo '</fieldset>';
	    */
	    echo '</fieldset>' . "\n";
	    echo '<input type="hidden" id="skype_button_widget_submited" name="skype_button_widget_submited" value="1" />' . "\n";
    }    
    
    function skype_button_widget($args) {
      extract($args);
		
		  $options = get_option('skype_button_widget');
		  
		  $skype_id = $options['skype_id'];
		  $button_theme = $options['button_theme'];
		  $title = $options['title'];
      
      $buttondir = dirname(__FILE__) . '/skype_buttons/';
      $file = $buttondir . $button_theme . '.html';
      if (!file_exists($file)) {
    		$file = $buttondir . 'transparent_dropdown.html';
    	}
    	
    	$fc = file_get_contents($file);
    	echo $before_widget;
    	if ($title != '') {
				echo $before_title . $title . $after_title;
			}
			
			echo '<ul><li>';
	    echo str_replace("{skypeid}", $skype_id, $fc);
	    echo '</li></ul>';
      
      echo $after_widget;
    }
    
    function skype_button_page_header() {
    	$options = get_option('skype_button_widget');
    	
    	if (empty($options["skype_id"])) {
    		return "";
    	}
    	
    	if ($options['button_theme'] == 'white_dropdown') {
    		print '<script type="text/javascript" src="http://download.skype.com/share/skypebuttons/buttons/white_dropdown/dropdown.js"></script>';
    		// I have no idea why but clear: both declaration in the Skype generated stylesheet screws up
    		// the default layout, this is a workaround
    		print '<style type="text/css">#skypeWhiteDrp { clear: none !important; };</style>';
    	}
    	if ($options['button_theme'] == 'transparent_dropdown') {
    		print '<script type="text/javascript" src="http://download.skype.com/share/skypebuttons/buttons/transparent_dropdown/dropdown.js"></script>';
    		print '<style type="text/css">#skypeTransparentDrp { clear: none !important; };</style>';
    	}
    	print '<script type="text/javascript" src="http://download.skype.com/share/skypebuttons/js/skypeCheck.js"></script>';
    }
    
    // helper functions to make sure that only valid data gets into database
    function skype_button_valid_id_wg($id) {
    	return preg_match("/^(\w|\.)*$/",$id);
    }
    
    function skype_button_valid_theme_wg($theme) {
    	return !preg_match("/\W/",$theme);
    }
    
    register_sidebar_widget('Skype Button', 'skype_button_widget');
    register_widget_control('Skype Button', 'skype_button_widget_control', 350, 450);
    add_action('wp_head', 'skype_button_page_header');
  }
  add_action('plugins_loaded', 'skype_button_widget_init');
?>